#include <iostream>
using namespace std;
int main()
{
    long long N, Q;
    cin>>N>>Q;
    
    long long d[N], p[N];
    for(long long i = 0; i<N; i++){
        cin>>d[i]>>p[i];
    }
    
    long long k[Q];
    for(long long j = 0; j<Q; j++){
        cin>>k[j];
    }
    
    long long brojPlazme = 0;
    long long pojedenaPlazma = 0;
    long long rez[Q];
    
    long long dan = 0;
    long long index = 0;
    
    for(long long i = 0; i<=k[Q-1]; i++){
        if(i == d[dan]){
            brojPlazme += p[dan];
            dan++;
        }
        if(brojPlazme > 0){
            pojedenaPlazma++;
            brojPlazme--;
        }
        if(i == k[index]){
            rez[index] = pojedenaPlazma;
            cout<<rez[index]<<endl;
            index++;
        }
    }
    return 0;
}